%define section     free
%define name        jetty50
%define jettyname   jetty
%define jtuid       110
%define confdir	    %{_sysconfdir}/%{name}
%define logdir	    %{_localstatedir}/log/%{name}
%define homedir	    %{_datadir}/%{name}
%define tempdir	    %{_localstatedir}/cache/%{name}/temp
%define rundir	    %{_localstatedir}/run/%{name}
%define libdir	    %{_localstatedir}/lib/%{name}/lib
%define appdir	    %{_localstatedir}/lib/%{name}/webapps
%define demodir	    %{_localstatedir}/lib/%{name}/demo

Name:           %{name}
Version:        5.0.0
Release:        4jpp
Epoch:          0
Summary:        The Jetty Webserver and Servlet Container

Group:          Networking/Daemons
License:        Open Source
URL:            http://jetty.mortbay.org/jetty/
Source0:        %{jettyname}-%{version}-all.tar.gz
Source1:        jetty5.script
Source2:        jetty5.init
Patch0:		jetty5-5.0.0-jpp.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Distribution:   JPackage
Vendor:         JPackage Project

BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:  perl >= 0:5.005
# build only
BuildRequires:  jakarta-commons-collections
BuildRequires:  ant-junit
BuildRequires:  junit
BuildRequires:  xdoclet
BuildRequires:  xjavadoc
# main
BuildRequires:  ant >= 0:1.6
BuildRequires:  jakarta-commons-el
BuildRequires:  jakarta-commons-logging
BuildRequires:  jasper5
BuildRequires:  jsse
BuildRequires:  mx4j >= 0:2.0
BuildRequires:  servletapi5
BuildRequires:  xerces-j2 >= 0:2.6.2
BuildRequires:  xml-commons-apis
# extra 
BuildRequires:  carol
BuildRequires:  hsqldb
BuildRequires:  jaf
BuildRequires:  jakarta-commons-cli
BuildRequires:  javamail
BuildRequires:  jboss >= 0:3.2
# jonas_timer
# objectweb-datasource
BuildRequires:  jotm
BuildRequires:  jta
BuildRequires:  jts
BuildRequires:  log4j
BuildRequires:  xapool
#
#Requires:  chkconfig
Requires:  jpackage-utils >= 0:1.5, ant >= 0:1.6
Requires:  jakarta-commons-el
Requires:  jakarta-commons-logging
Requires:  jasper5
Requires:  jsse
Requires:  mx4j >= 0:2.0
Requires:  servletapi5
Requires:  xerces-j2 >= 0:2.6.2
Requires:  xml-commons-apis

%description
Jetty is a 100% Java HTTP Server and Servlet Container. 
This means that you do not need to configure and run a 
separate web server (like Apache) in order to use java, 
servlets and JSPs to generate dynamic content. Jetty is 
a fully featured web server for static and dynamic content. 
Unlike separate server/container solutions, this means 
that your web server and web application run in the same 
process, without interconnection overheads and complications. 
Furthermore, as a pure java component, Jetty can be simply 
included in your application for demonstration, distribution 
or deployment. Jetty is available on all Java supported 
platforms.  

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
%{summary}.

%package        demo
Summary:        Examples for %{name}
Group:          Development/Documentation
Requires:       %{name} = 0:%{version}

%description    demo
%{summary}.

%package        extra
Summary:        Extras for %{name}
Group:          Networking/Daemons
Requires:       %{name} = 0:%{version}
Requires:  hsqldb
Requires:  jaf
Requires:  jakarta-commons-cli
Requires:  javamail
# jonas_timer
# objectweb-datasource
Requires:  jotm
Requires:  jta
Requires:  jts
Requires:  log4j
Requires:  xapool

%description    extra
The purpose of this project is to enrich Jetty by 
selectively incorporating useful J2EE and non-J2EE 
features. The result is JettyPlus, an environment 
offering additional facilities to core web and servlet 
services, but which does not entail a full-blown 
application server (such as JettyJBoss and JettyJOnAS). 
The feature set currently contains: 
Java Transaction API (JTA) and Resource references, eg DataSources 
Java Naming and Directory Interface API (JNDI) 
Log4J 
Java Authentication and Authorization Service (JAAS) 
Java Mail  
These features have been implemented as a pluggable, 
Service-based architecture. This means that it is 
possible to develop and use alternative services to 
those provided. 


%package        manual
Summary:        Documents for %{name}
Group:          Development/Documentation
Requires:       %{name} = 0:%{version}

%description    manual
%{summary}.


%prep
%setup -q -n %{jettyname}-%{version}
#for f in $(find . -name "*.jar"); do mv $f $f.not; done
find . -name "*.jar" -exec rm {} \;
# .war files needed for tests
mv demo/webapps/servlets-examples.war demo/webapps/servlets-examples.war.sav
mv demo/webapps/jsp-examples.war demo/webapps/jsp-examples.war.sav
find . -name "*.war" -exec rm {} \;
mv demo/webapps/servlets-examples.war.sav demo/webapps/servlets-examples.war
mv demo/webapps/jsp-examples.war.sav demo/webapps/jsp-examples.war
echo jboss.home = /var/lib/jboss >> ant.properties

%patch0 -b .sav

%build
pushd ext
  ln -s $(build-classpath ant) .
  ln -s $(build-classpath commons-el) .
  ln -s $(build-classpath commons-logging) .
  ln -s $(build-classpath jasper5-compiler) jasper-compiler.jar
  ln -s $(build-classpath jasper5-runtime)  jasper-runtime.jar
  ln -s $(build-classpath mx4j/mx4j-impl) .
  ln -s $(build-classpath mx4j/mx4j-jmx) .
  ln -s $(build-classpath mx4j/mx4j-tools) .
  ln -s $(build-classpath xerces-j2) xercesImpl.jar
  ln -s $(build-classpath xml-commons-apis) xml-apis.jar
  #xmlParserAPIs-2.5.jar
popd
pushd extra/ext
  ln -s $(build-classpath jaf) activation.jar
  ln -s $(build-classpath carol/carol) .
  ln -s $(build-classpath commons-cli) .
  ln -s $(build-classpath hsqldb) .
  #jonas_timer.jar
  ln -s $(build-classpath jotm/jotm) .
  ln -s $(build-classpath jotm/iiop-stubs) jotm_iiop_stubs.jar
  ln -s $(build-classpath jotm/jrmp-stubs) jotm_jrmp_stubs.jar
  ln -s $(build-classpath jta) jta-spec1_0_1.jar
  ln -s $(build-classpath jts) jts1_0.jar
  ln -s $(build-classpath log4j) .
  ln -s $(build-classpath javamail/mailapi) mail.jar
  #objectweb-datasource.jar
  ln -s $(build-classpath xapool) .
popd


export OPT_JAR_LIST="ant/ant-junit junit xjavadoc commons-collections commons-logging"
export CLASSPATH=$(build-classpath \
xapool \
javamail/mailapi \
jta \
log4j \
)

ant  -Dbuild.sysclasspath=first all extra

%install
rm -rf $RPM_BUILD_ROOT
# dirs
install -dm 755 $RPM_BUILD_ROOT%{_bindir}
install -dm 755 $RPM_BUILD_ROOT%{_sysconfdir}/init.d
install -dm 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -dm 755 $RPM_BUILD_ROOT%{confdir}
install -dm 755 $RPM_BUILD_ROOT%{confdir}/extra
install -dm 755 $RPM_BUILD_ROOT%{demodir}
install -dm 755 $RPM_BUILD_ROOT%{homedir}
install -dm 755 $RPM_BUILD_ROOT%{homedir}/bin
install -dm 755 $RPM_BUILD_ROOT%{homedir}/ext
install -dm 755 $RPM_BUILD_ROOT%{homedir}/extra
install -dm 755 $RPM_BUILD_ROOT%{homedir}/extra/ext
install -dm 755 $RPM_BUILD_ROOT%{libdir}
install -dm 755 $RPM_BUILD_ROOT%{libdir}/extra
install -dm 755 $RPM_BUILD_ROOT%{logdir}
install -dm 755 $RPM_BUILD_ROOT%{rundir}
install -dm 755 $RPM_BUILD_ROOT%{tempdir}
install -dm 755 $RPM_BUILD_ROOT%{appdir}
# main pkg
install -pm 755 extra/unix/bin/jetty.sh $RPM_BUILD_ROOT%{_bindir}/d%{name}
install -pm 755 %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/%{name}
install -pm 755 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/init.d/%{name}
install -pm 644 start.jar $RPM_BUILD_ROOT%{homedir}/bin
install -pm 644 stop.jar $RPM_BUILD_ROOT%{homedir}/bin
cp -pr etc/* $RPM_BUILD_ROOT%{confdir}
install -pm 644 lib/org.mortbay.jetty.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-%{version}.jar
install -pm 644 lib/org.mortbay.jmx.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-jmx-%{version}.jar
install -pm 644 lib/javax.servlet.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-servlet-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
pushd $RPM_BUILD_ROOT%{libdir}
  ln -sf %{_javadir}/%{name}/%{name}.jar org.mortbay.jetty.jar
  ln -sf %{_javadir}/%{name}/%{name}-jmx.jar org.mortbay.jmx.jar
popd
( cat << EO_RC
JAVA_HOME=/usr/lib/jvm/java
JAVA_OPTIONS=
JETTY_HOME=%{homedir}
JETTY_CONSOLE=%{logdir}/jetty-console.log
JETTY_PORT=8080
JETTY_RUN=%{_localstatedir}/run/%{name}
JETTY_PID=\$JETTY_RUN/jetty4.pid
EO_RC
) > $RPM_BUILD_ROOT%{homedir}/.jettyrc

# extra
cp -pr extra/etc/* $RPM_BUILD_ROOT%{confdir}/extra
rm $RPM_BUILD_ROOT%{confdir}/extra/LICENSE.apache.txt
rm $RPM_BUILD_ROOT%{confdir}/extra/LICENSE.hsqldb.html
rm $RPM_BUILD_ROOT%{confdir}/extra/LICENSE.p6spy.html

install -pm 644 extra/lib/org.jboss.jetty.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-jboss-%{version}.jar
install -pm 644 extra/lib/org.mortbay.ftp.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-ftp-%{version}.jar
install -pm 644 extra/lib/org.mortbay.j2ee.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-j2ee-%{version}.jar
install -pm 644 extra/lib/org.mortbay.jaas.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-jaas-%{version}.jar
# omit for 1.6
# install -pm 644 extra/lib/org.mortbay.jetty-jdk1.2.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-jetty-jdk1.2-%{version}.jar
install -pm 644 extra/lib/org.mortbay.jetty.plus.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-plus-%{version}.jar
# omit for 1.6
# install -pm 644 extra/lib/org.mortbay.jmx-jdk1.2.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-jmx-jdk1.2-%{version}.jar
install -pm 644 extra/lib/org.mortbay.loadbalancer.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-loadbalancer-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
pushd $RPM_BUILD_ROOT%{libdir}/extra
  ln -sf %{_javadir}/%{name}/%{name}-jboss.jar org.jboss.jetty.jar
  ln -sf %{_javadir}/%{name}/%{name}-ftp.jar org.mortbay.ftp.jar
  ln -sf %{_javadir}/%{name}/%{name}-j2ee.jar org.mortbay.j2ee.jar
  ln -sf %{_javadir}/%{name}/%{name}-jaas.jar org.mortbay.jaas.jar
  ln -sf %{_javadir}/%{name}/%{name}-plus.jar org.mortbay.jetty.plus.jar
  ln -sf %{_javadir}/%{name}/%{name}-loadbalancer.jar org.mortbay.loadbalancer.jar
popd

# demo
cp -pr demo/* $RPM_BUILD_ROOT%{demodir}

# javadoc
cp -pr webapps/* $RPM_BUILD_ROOT%{appdir}
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
pushd $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
unzip -q $RPM_BUILD_ROOT%{appdir}/javadoc.war
popd
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p {LICENSE.TXT,VERSION.TXT} $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
mv $RPM_BUILD_ROOT%{demodir}/webapps/jetty/* \
                $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
rm -rf $RPM_BUILD_ROOT%{appdir}/jetty


pushd $RPM_BUILD_ROOT%{homedir}
   [ -d conf ]    || ln -fs %{confdir}   conf
   [ -d demo ]    || ln -fs %{demodir}   demo
   [ -d logs ]    || ln -fs %{logdir}    logs
   [ -d lib ]     || ln -fs %{libdir}    lib
   [ -d temp ]    || ln -fs %{tempdir}   temp
   [ -d webapps ] || ln -fs %{appdir}    webapps
   pushd extra
     [ -d conf ]    || ln -fs %{confdir}/extra  conf
     [ -d lib ]    || ln -fs %{libdir}/extra    lib
   popd
popd

#fix paths

perl -pi -e 's#etc/#conf/#g;' $RPM_BUILD_ROOT%{confdir}/*.xml


%clean
rm -rf $RPM_BUILD_ROOT

%pre
# Add the "jetty5" user and group
# we need a shell to be able to use su - later
%{_sbindir}/groupadd -g %{jtuid} %{name} 2> /dev/null || :
%{_sbindir}/useradd -c "Jetty5" -u %{jtuid} -g %{name} \
    -s /bin/sh -d %{homedir} %{name} 2> /dev/null || :

%post
[ -x /sbin/chkconfig ] && /sbin/chkconfig --add %{name}

# create the main jar repository
build-jar-repository -s %{homedir}/ext \
   ant \
   jasper5-compiler \
   jasper5-runtime \
   mx4j/mx4j-jmx \
   mx4j/mx4j-tools \
   servletapi5 \
   xerces-j2 \
   xml-commons-apis \
   jsse/jcert \
   jsse/jnet \
   jsse/jsse

%post extra
  #jonas_timer.jar
  #objectweb-datasource.jar
build-jar-repository -s %{homedir}/extra/ext \
  jaf \
  carol/carol \
  commons-cli \
  hsqldb \
  jotm/jotm \
  jotm/iiop-stubs \
  jotm/jrmp-stubs \
  jta \
  jts \
  log4j \
  javamail/mailapi \
  xapool 


%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}
rm -f %{homedir}/javadoc
ln -s %{_javadocdir}/%{name} %{homedir}/javadoc

%post manual
rm -rf %{demodir}/webapps/jetty
mkdir -p %{demodir}/webapps
ln -s %{_docdir}/%{name}-%{version} %{demodir}/webapps/jetty


%preun
if [ $1 = 0 ]; then
    [ -f /var/lock/subsys/%{name} ] && %{_sysconfdir}/init.d/%{name} stop
    [ -f %{_sysconfdir}/init.d/%{name} -a -x /sbin/chkconfig ] && /sbin/chkconfig --del %{name}

    %{_sbindir}/userdel %{name} >> /dev/null 2>&1 || :
    %{_sbindir}/groupdel %{name} >> /dev/null 2>&1 || :

    # Remove automated symlinks
    for repository in %{homedir}/ext ; do
        find $repository -name '\[*\]*.jar' ! -type d -exec rm -f {} \;
    done
fi

%preun extra
  for repository in %{homedir}/extra/ext ; do
      find $repository -name '\[*\]*.jar' ! -type d -exec rm -f {} \;
  done

%files
%defattr(-,root,root,-)
%{_bindir}/*
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/%{name}-%{version}.jar
%{_javadir}/%{name}/%{name}-jmx-%{version}.jar
%{_javadir}/%{name}/%{name}-servlet-%{version}.jar
%{_javadir}/%{name}/%{name}.jar
%{_javadir}/%{name}/%{name}-jmx.jar
%{_javadir}/%{name}/%{name}-servlet.jar
%dir %config %{confdir}
%config (noreplace)%{confdir}/[^e]*
%config(noreplace) %{confdir}/examplesRealm.properties
%dir %{libdir}
%{libdir}/org.*
%dir %{homedir}
%{homedir}/[^e]*
%{homedir}/ext
%config(noreplace) %{homedir}/.jettyrc
%dir %{demodir}
%attr(755, jetty50, jetty50) %{logdir}
%attr(755, jetty50, jetty50) %{tempdir}
%attr(755, jetty50, jetty50) %{rundir}
%dir %{appdir}
%doc %{_docdir}/%{name}-%{version}/LICENSE.TXT
%doc %{_docdir}/%{name}-%{version}/VERSION.TXT
%attr(755, root, root) %{_sysconfdir}/init.d/%{name}

%files demo
%defattr(-,root,root,-)
%{demodir}

%files javadoc
%defattr(-,root,root,-)
%{appdir}/template
%{appdir}/javadoc.war
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}-%{version}

%files extra
%defattr(-,root,root,-)
%{_javadir}/%{name}/%{name}-ftp-%{version}.jar
%{_javadir}/%{name}/%{name}-ftp.jar
%{_javadir}/%{name}/%{name}-j2ee-%{version}.jar
%{_javadir}/%{name}/%{name}-j2ee.jar
%{_javadir}/%{name}/%{name}-jaas-%{version}.jar
%{_javadir}/%{name}/%{name}-jaas.jar
%{_javadir}/%{name}/%{name}-jboss-%{version}.jar
%{_javadir}/%{name}/%{name}-jboss.jar
%{_javadir}/%{name}/%{name}-loadbalancer-%{version}.jar
%{_javadir}/%{name}/%{name}-loadbalancer.jar
%{_javadir}/%{name}/%{name}-plus-%{version}.jar
%{_javadir}/%{name}/%{name}-plus.jar
%config(noreplace) %{confdir}/extra
%{homedir}/extra
%{libdir}/extra

%changelog
* Wed Mar 30 2005 Ralph Apel <r.apel@r-apel.de> - 0:5.0.0-4jpp
- Also install as jetty50 user (thx Bernard Johnson)

* Wed Feb 02 2005 Ralph Apel <r.apel@r-apel.de> - 0:5.0.0-3jpp
- BuildRequire carol (thx Kaj)
- Fix some attributes in files sections

* Tue Jan 04 2005 Ralph Apel <r.apel@r-apel.de> - 0:5.0.0-2jpp
- Include build of extra, so called JettyPlus
- Create own subdirectory for jetty50 in %{_javadir}
- Change %{_homedir}/conf to %{_homedir}/etc
- Dropped chkconfig requirement; just exec if /sbin/chkconfig available
- Fixed unpackaged .jettyrc

* Mon Oct 04 2004 Ralph Apel <r.apel@r-apel.de> - 0:5.0.0-1jpp
- Upgrade to 5.0.0
- Fixed URL
- relaxed some versioned dependencies

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:4.2.20-2jpp
- Rebuild with ant-1.6.2

* Fri Jun 18 2004 Ralph Apel <r.apel@r-apel.de> - 0:4.2.20-1jpp
- Upgrade to 4.2.20
- Drop ownership of /usr/share/java and /usr/bin

* Tue Feb 24 2004 Ralph Apel <r.apel@r-apel.de> - 0:4.2.17-2jpp
- enhancements and corrections thanks to Kaj J. Niemi:
- $JETTY_HOME/ext didn't exist but %post depended on it
- correctly shutdown jetty upon uninstall
- RedHat depends on chkconfig/service to work so a functional
  init.d/jetty4 needed to be created
- djetty4 (jetty.sh) did funny things especially when it attempted to guess
  stuff
- a lot of .xml config files assumed that the configs were in etc/ instead of
  conf/

* Thu Feb 19 2004 Ralph Apel <r.apel@r-apel.de> - 0:4.2.17-1jpp
- First JPackage release.
